#include "StdAfx.h"
#define INITGUID
#include <initguid.h>
#include "POOM.h"

#ifndef RELEASE_OBJ
#define RELEASE_OBJ(s)  \
    if (s != NULL)      \
    {                   \
        s->Release();   \
        s = NULL;       \
    }
#endif //RELEASE_OBJ


using namespace POOM;

CApp::CApp(void) :
	m_pApp(NULL),
	m_pContactFolder(NULL),
	m_pContactItems(NULL)
{
	HRESULT hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);
	if (hr == S_FALSE) {
		//ɏ
		m_AlreadyInitialized = TRUE;
	} else if (FAILED(hr)) {
		//G[
		throw _T("POOM̏Ɏs܂B");
	}

	hr = CoCreateInstance(
		CLSID_Application,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_IPOutlookApp,
		(LPVOID*)&m_pApp);
	if (FAILED(hr)) throw _T("POOM̏Ɏs܂B");

	hr = m_pApp->Logon(NULL);
	if (FAILED(hr)) throw _T("POOM̃OCɎs܂B");
}

CApp::~CApp(void)
{
	RELEASE_OBJ(m_pContactItems);
	RELEASE_OBJ(m_pContactFolder);

	m_pApp->Logoff();
	m_pApp->Release();

	if (!m_AlreadyInitialized) {
		CoUninitialize();
	}
}

IPOutlookApp &CApp::GetApp()
{
	return *m_pApp;
}

IPOutlookItemCollection *CApp::GetContacts(void)
{
	if (m_pContactItems != NULL) {
		return m_pContactItems;
	}

	HRESULT hr = 0;
	
	hr = m_pApp->GetDefaultFolder(olFolderContacts, &m_pContactFolder);
	if (FAILED(hr)) throw _T("AtH_̎擾Ɏs܂B");
	hr = m_pContactFolder->get_Items(&m_pContactItems);
	if (FAILED(hr)) throw _T("AACeXg̎擾Ɏs܂B");

	return m_pContactItems;
}